#!/bin/bash
#
# 同步二进制包到源,
# 根据本地 pbs 文件库更新universe文件
#
#

. /usr/lib/ypkg/ypkg-func
s="$YPPATH_LIB/universe"
l="$YPPATH_LOCAL_UNI"

#
tmpfile=$(mktemp)
cd $(dirname $0)

if [ -f $l ]; then
	grep ^# $l |while read i;do 
		T=$(echo $i |awk '{print $2}')
		N=$(echo $i |awk '{print $3}')
		V=$(echo $i |awk '{print $4}')
		R=$(echo $i |awk '{print $5}')
		ymsg "* merge $T/${N}_$V$R ..."
        	tmpfile=$(ypkg_mktemp f)
        	#
		sed -i '/# '"$T $N $V$R"'/d'                               $l
        	ypkg_find_info $s "remove"
		ypkg_find_info $l           >$tmpfile
		echo 							   >>$s	
		cat	$tmpfile					   >>$s
		echo                 					   >>$s
	        ypkg_find_info $l "remove"
		sed -i '/^#/d' 					           $s
		sed -i '$!N; /^\(.*\)\n\1$/!P; D' 		  	   $l $s
	done
fi

ymsg "* rsync /var/ypkg/packages/* /var/ftp/public/packages/"
rsync -avi /var/ypkg/packages/*  /var/ftp/public/packages/

ymsg "* check local universe file"
if [ "x$(cat $l 2>/dev/null)" != "x" ]; then
	echo "local universe file has content, it is wrong!"
	exit 
fi
echo

cd $YPPATH_LIB
tmpfile1=$(mktemp)
git diff |grep "diff --git" |grep pbs$ |tr ' ' '\n' |sed -e '/^diff$/d' -e '/^--git$/d' -e 's/^a\///g' -e 's/^b\///g' |sort -u >$tmpfile1
ymsg "* modified pbs files:"
cat $tmpfile1
echo

ymsg "* find out pbsfiles which was modified REPO or deleted, and update universe.."
cat $tmpfile1 |while read i; do
	pbsfile=$YPPATH_LIB/${i}
	if [ ! -f $pbsfile ]; then
		atom_parse_path $pbsfile
		if ypkg_find_info   $s  "remove"; then
			ymsg "*$pbsfile was deleted, remove $T/${N}_$V$R from $s"
		fi
		continue
	else
		. $pbsfile	
	fi
	[ "x$REPO" = "x" ] && newrepo="stable" || newrepo="$REPO"
	atom_parse_path $pbsfile
	tmpfile2=$(mktemp)
        ypkg_find_info   $s   >$tmpfile2
	. $tmpfile2
	if [ "x$REPO" = "x" ]; then
		oldrepo="stable"
	else
		oldrepo="$REPO"
	fi
	if [ "x$oldrepo" != "x$newrepo" ]; then
		echo "* update ${i} in $s"
		sed -i 's/REPO="'"$oldrepo"'"/REPO="'"$newrepo"'"/g' $tmpfile2
		ypkg_find_info $s "remove"
		echo  >> $s
		cat $tmpfile2 >> $s
		sed -i '$!N; /^\(.*\)\n\1$/!P; D'      $s
	fi
done

rm $tmpfile $tmpfile1 $tmpfile2 

